<div class="panel panel-default">
	<div class="panel-heading"  anim-type="collapse" anim-target="#info-menu">
		<h2 class="panel-title">Patient Info</h2>
	</div>
	
	<div class="panel-body" id="info-menu">
		<ul class="nav nav-sidebar">
			<li><a href="/iTrust/auth/hcp-uap/viewPreRegisteredPatientList.jsp">View Pre-Registered Patients</a>
		    <li><a href="/iTrust/auth/hcp-uap/viewPatientOfficeVisitHistory.jsp">All Patients</a>
			<li><a href="/iTrust/auth/hcp-uap/viewBasicHealth.jsp">Basic Health Information</a>
			<li><a href="/iTrust/auth/hcp-uap/editPatient.jsp">Patient Information</a>
			<li><a href="/iTrust/auth/hcp-uap/editPHR.jsp">PHR Information</a>
			<li><a href="/iTrust/auth/hcp/editRepresentatives.jsp">Representatives</a>
			<li><a href="/iTrust/auth/hcp-uap/viewImmunizations.jsp">Immunization Report</a>
		    <li><a href="/iTrust/auth/hcp-er/emergencyReport.jsp">Emergency Patient Report</a>
		    <li><a href="/iTrust/auth/hcp-uap/viewMyReportRequests.jsp">My Report Requests</a>
		    <li><a href="/iTrust/auth/hcp-uap/viewRecordsReleases.jsp">Records Release Requests</a>
		    <li><a href="/iTrust/auth/hcp-uap/chronicDiseaseRisks.jsp">Chronic Disease Risks</a>
			<li><a href="/iTrust/auth/hcp-pha/viewDiagnosisStatistics.jsp">Diagnosis Trends</a>
			<li><a href="/iTrust/auth/hcp/groupReport.jsp">Group Report</a>
			<li><a href="/iTrust/auth/hcp/changeDependency.jsp">Patient Dependency</a>
			<li><a href="/iTrust/auth/hcp-uap/deactivatePatient.jsp">Deactivate Patient</a>
			<li><a href="/iTrust/auth/hcp/auditPage.jsp">Audit Patients</a>
			<li><a href="/iTrust/auth/hcp-nutritionist/viewFoodDiaries.jsp">Patient Food Diaries</a>
			<li><a href="/iTrust/auth/hcp-nutritionist/macronutrients.jsp">Patient Macronutrient Intake</a>
			<li><a href="/iTrust/auth/hcp-fitness/viewExerciseDiaries.jsp">Patient Exercise Diaries</a>
			<li><a href="/iTrust/auth/hcp/viewSleepDiaries.jsp">Patient Sleep Diaries</a>
		</ul>
	</div>
</div>

<div class="panel panel-default">
	<div class="panel-heading"  anim-type="collapse" anim-target="#appt-menu">
		<h2 class="panel-title">Appointments</h2>
	</div>
	<div class="panel-body" id="appt-menu">
		<ul class="nav nav-sidebar">
			<li><a href="/iTrust/auth/hcp/scheduleAppt.jsp">Schedule Appointment</a>
			<li><a href="/iTrust/auth/hcp/viewMyAppts.jsp">View My Appointments</a>
			<li><a href="/iTrust/auth/hcp/viewMyApptRequests.jsp">Appointment Requests</a>
		    <li><a href="/iTrust/auth/hcp/calendar.jsp">Appointment Calendar</a>
		</ul>
	</div>
</div>

<div class="panel panel-default">
	<div class="panel-heading"   anim-type="collapse" anim-target="#ov-menu">
		<h2 class="panel-title">Office Visits</h2>
	</div>
	<div class="panel-body" id="ov-menu">
		<ul class="nav nav-sidebar">
		   <li><a href="/iTrust/auth/hcp-uap/documentOfficeVisit.jsp">Document Office Visit</a>
		   <li><a href="/iTrust/auth/hcp/visitReminders.jsp">Office Visit Reminders</a>
		   <li><a href="/iTrust/auth/hcp/LabProcHCP.jsp">Laboratory Procedures</a>
		   <li><a href="/iTrust/auth/hcp-uap/viewSentReferrals.jsp">Sent Referrals</a>
		   <li><a href="/iTrust/auth/hcp-uap/viewReceivedReferrals.jsp">Received Referrals</a>
		</ul>
	</div>
</div>

<div class="panel panel-default">
	<div class="panel-heading"  anim-type="collapse" anim-target="#msg-menu">
		<h2 class="panel-title">Messaging</h2>
	</div>
	<div class="panel-body" id="msg-menu">
		<ul class="nav nav-sidebar">
			<li><a href="/iTrust/auth/hcp/sendMessage.jsp">Compose a Message</a>
			<li><a href="/iTrust/auth/hcp-patient/messageInbox.jsp">Message Inbox</a>
			<li><a href="/iTrust/auth/hcp-patient/messageOutbox.jsp">Message Outbox</a>
		    <li><a href="/iTrust/auth/hcp-uap/showEmailHistory.jsp">Email History</a>
		</ul>
	</div>
</div>

<div class="panel panel-default">
	<div class="panel-heading"  anim-type="collapse" anim-target="#tele-menu">
		<h2 class="panel-title">Telemedicine</h2>
	</div>
	<div class="panel-body" id="tele-menu">
		<ul class="nav nav-sidebar">
			<li><a href="/iTrust/auth/hcp/editPatientList.jsp">Edit Patient List</a>
			<li><a href="/iTrust/auth/hcp/monitorPatients.jsp">Monitor Patients</a>
		</ul>
	</div>
</div>

<div class="panel panel-default">
	<div class="panel-heading"  anim-type="collapse" anim-target="#add-menu">
		<h2 class="panel-title">Add</h2>
	</div>
	<div class="panel-body" id="add-menu">
		<ul class="nav nav-sidebar">
		   <li><a href="/iTrust/auth/hcp-uap/addPatient.jsp">Patient</a></li>
		   <li><a href="/iTrust/auth/hcp-uap/uploadPatientFile.jsp">Upload Patient File</a></li>
		   <li><a href="/iTrust/auth/hcp/addUAP.jsp">UAP</a></li>
		</ul>
	</div>
</div>

<div class="panel panel-default">
	<div class="panel-heading"  anim-type="collapse" anim-target="#pi-menu">
		<h2 class="panel-title">Personal Info</h2>
	</div>
	<div class="panel-body" id="pi-menu">
		<ul class="nav nav-sidebar">
   			<li><a href="/iTrust/auth/staff/editMyDemographics.jsp">My Demographics</a>
		</ul>
	</div>
</div>

<div class="panel panel-default">
	<div class="panel-heading"  anim-type="collapse" anim-target="#ob-menu">
		<h2 class="panel-title">Obstetrics</h2>
	</div>
	<div class="panel-body" id="ob-menu">
		<ul class="nav nav-sidebar">
			<li><a href="/iTrust/auth/hcp/obstetricsHome.jsp">Obstetrics Home</a></li>
			<li><a href="/iTrust/auth/hcp/addObstetricsInitialRecord.jsp">Initialize Obstetrics Patient</a></li>
			<li><a href="/iTrust/auth/hcp/obstetricsHome.jsp?view">View Obstetrics Records</a></li>
			<li><a href="/iTrust/auth/hcp/addObstetricsOfficeVisit.jsp">Add Obstetrics Office Visit</a></li>
			<li><a href="/iTrust/auth/hcp/obstetricsPreExistingConditions.jsp">Patient Pre-existing Conditions</a></li>
			<li><a href="/iTrust/auth/hcp/obstetricsAlergies.jsp">Patient Allergies</a></li>
			<li><a href="/iTrust/auth/hcp/laborDeliveryReport.jsp">Labor and Delivery Report</a></li>
		</ul>
	</div>
</div>

<div class="panel panel-default">
	<div class="panel-heading"  anim-type="collapse" anim-target="#oph-menu">
		<h2 class="panel-title">Ophthalmology</h2>
	</div>
	<div class="panel-body" id="oph-menu">
		<ul class="nav nav-sidebar">
			<li><a href="/iTrust/auth/hcp/ophthalmologyHome.jsp">Ophthalmology Home</a></li>
			<li><a href="/iTrust/auth/hcp/viewOphthalmologyScheduleRequests.jsp">View Ophthalmology Office Visit Requests</a></li>
			<li><a href="/iTrust/auth/hcp/viewOphthalmologyScheduleOV.jsp">View Scheduled Ophthalmology Office Visits</a></li>
			<li><a href="/iTrust/auth/hcp/ophthalmologyHome.jsp?view">View Ophthalmology Records</a></li>
			<li><a href="/iTrust/auth/hcp/addOphthalmologyOV.jsp">Add Ophthalmology Office Visit</a></li>
			<li><a href="/iTrust/auth/hcp/ophthalmologySurgeryHome.jsp">Surgical Ophthalmology Home</a></li>
			<li><a href="/iTrust/auth/hcp/ophthalmologySurgeryHome.jsp?view">View Surgical Ophthalmology Records</a></li>
			<li><a href="/iTrust/auth/hcp/addOphthalmologySurgery.jsp">Add Surgical Ophthalmology Office Visit</a></li>
		</ul>
	</div>
</div>

<div class="panel panel-default">
	<div class="panel-heading"  anim-type="collapse" anim-target="#other-menu">
		<h2 class="panel-title">Other</h2>
	</div>
	<div class="panel-body" id="other-menu">
		<ul class="nav nav-sidebar">
		    <li><a href="/iTrust/auth/staff/linkToResources.jsp">Edit Diagnoses URLs</a>
		    <li><a href="/iTrust/auth/hcp/manageWards.jsp">Manage Wards</a>
		    <li><a href="/iTrust/auth/staff/editPersonnel.jsp">UAPs</a>
			<li><a href="/iTrust/auth/surveyResults.jsp">Satisfaction Survey Results</a>
			<li><a href="/iTrust/auth/hcp/viewPrescriptionRenewalNeeds.jsp">Potential Prescription-Renewals</a>
		</ul>
	</div>
</div>
